#include <iostream.h>


class hanoi{
int discs;

void move( int discs, int src, int dest, int aux );
public:
 hanoi( int discs );
~hanoi( void );
 void solveHanoi( void );
};


hanoi::hanoi(int discs){
 this->discs = discs;
}

void hanoi::move(int discs,int src, int dest, int aux ){
 if( discs == 1 ){  
  cout << src << " " << dest << endl; 
  return;
 }
 move(discs-1,src,aux,dest);
 cout << src << " " << dest << endl; 
 move(discs-1,aux,dest,src); 
}

void hanoi::solveHanoi(void){
 move(discs,1,3,2); 
}

hanoi::~hanoi(void){
//cout << "\n Bye \n";
}


int main(void){
//get the number of discs

int numDiscs=0;
cout <<"Welcome to the Towers of Hanoi\n";
do{
 numDiscs=0;
 cout << "How many rings do you have?\n";
 cin >> numDiscs;
}while( isdigit(numDiscs) && ((numDiscs < 1) || (numDiscs > 10)) );
hanoi* hanoidemo = new hanoi( numDiscs ); 
hanoidemo->solveHanoi();
delete hanoidemo;
return 0;
}
