#include <iostream.h>


/*Recursive function "hanoi" implements the hanoi algorithm*/
void hanoi (int disks,  const char * first,  const char * last,  const char * mid)
{
	if (disks >= 1) /*There are disks to be transferred..*/
	{
		hanoi(disks-1, first, mid, last); /*recursion*/
		printf("%s %s\n", first, last);
		hanoi(disks-1, mid, last, first); /*recursion*/
	}
}

int main ()
{
	int numdisks=0; /*user input*/
	cout << "Welcome to the Towers of Hanoi" << endl;
	cout << "How many disks do you have?    " ;
	cin  >> numdisks;
	while( (numdisks<1) || (numdisks>10) ) /*Range validator*/
	{
		cout << "How many disks do you have?    " ;
		cin  >> numdisks;
	}

	hanoi(numdisks, "1", "3", "2");  

   return 0;
}
	
	
