#include <stdio.h>

int other(int from, int to)
{
	return 6 - from - to;
}

int hanoi(int n, int from, int to)
{
	if( n == 1)
	{
		printf("%d %d\n", from, to);
		return 0;
	}
	else{
		int iTag = other(from, to);
		hanoi(n-1, from, iTag);
		printf("%d %d\n", from, to);
		return hanoi(n-1, iTag, to);
	}
}

int main(void)
{
	int n;
	printf("Welcome to the Towers of Hanoi\nHow many disks do you have?\n");
	scanf("%d", &n);
	while(n < 0 || n > 10)	
	{
		printf("How many disks?\n");
		scanf("%d", &n);
	}
	return hanoi(n, 1, 3);
}
